;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
; BILL OF QTYS for Original Style ..FASTRACK Database
; ISSUE 1: 21/ 12/ 1995 ISSUE 3: 29/ 03/ 2002
; by Mark Latimer for MICE Technical Graphics Limited 0208 668 4646
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun BOQ ( sOption / fFileIn lList iCount iNoOff lNoList)

   (onscr)

   (ExtractData)

   (setq fFileIn (OpenFile "c:/$TEMP.TXT" "r"))
   
   (prompt "\nCreating extraction file..")

   (if (/= fFileIn nil)
      (progn
         (setq lList (CreateList fFileIn))

         (setq iCount 0)
         (setq lNoList (list))

         (while (< iCount (length lList))
            (setq fFileIn (OpenFile "c:/$TEMP.TXT" "r"))
            (setq iNoOff (GetNoOff (nth iCount lList) fFileIn))
            (close fFileIn) ; $TEMP.TXT
            (setq lNoList (append (list iNoOff) lNoList))
            (setq iCount (1+ iCount))
         ) ; end while

         (cond
            ( (= sOption "1") (WriteData lList (reverse lNoList) 1) )
            ( (= sOption "2") (WriteData lList (reverse lNoList) 2) )
            ( (= sOption "3") (WriteData lList (reverse lNoList) 3) )
            (t nil)
         ) ; end cond

      ) ; end progn
   ) ; end if

   (command "SHELL" "erase c:/$temp.txt")

   (graphscr)

) ; end of BOQ()
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun WriteData ( lDataList lNoList bFlag / iCount fFileOut sNumOff lAttList temp)

   (setq fFileOut (OpenFile (strcat (GetFilename) ".BOQ") "w"))
   (prompt (strcat "\nWriting data to extract file <" (getvar "dwgname") ".BOQ> Please Wait..."))

   ; write the first two lines
   (write-line "ORIGINAL STYLE   VICTORIAN TILES   BILL OF MATERIALS" fFileOut)
   (write-line "**********************************************************" fFileOut)
   (write-line "   QUANTITY    TILE MODEL             TILE COLOUR        " fFileOut)
   (write-line "**********************************************************" fFileOut)

   (setq iCount 0)
   (while (< iCount (length lDataList))

      ; GetAttList returns a list of all the attribue data as separate elements
      ; within a list.
      (setq lAttList (GetAttList (nth iCount lDataList)))

      (setq temp (* 1.05 (nth iCount lNoList))
	    temp (fix (if (/= 0 (rem temp 1)) (+ 1 temp) temp) )
	    sNumOff (itoa temp))

      (cond
         ( (= (strlen sNumOff) 1) (setq sNumOff (strcat "   " sNumOff )))
         ( (= (strlen sNumOff) 2) (setq sNumOff (strcat "  "  sNumOff )))
         ( (= (strlen sNumOff) 3) (setq sNumOff (strcat " "   sNumOff )) )
      ) ; end cond

;      (print lAttList)

      (write-line (strcat "    "     sNumOff
                          "          "  (nth 0 lAttList) 
                          "          "  (nth 1 lAttList) 
                  ) fFileOut)

      (setq iCount (1+ iCount))

   ) ; end while

   (close fFileOut)

   (cond
      ( (= bFlag 1) (ReadFile) )
      (t nil)
   ) ; end file

) ; end function WriteData
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun ReadFile ( / sLine pPt rHt fFileIn)

   (setq fFileIn (OpenFile (strcat (GetFilename) ".BOQ") "r"))

   (setq pPt (list 0 0 0))
   (setq rHt (getreal "\nEnter text height: "))

   (setq sLine (read-line fFileIn))

   (if (/= sLine nil)
      (progn

         (while (/= sLine nil)

            (command ".TEXT" pPt rHt "0" sLine)
            (setq pPt (polar pPt (dtr 270) (* rHt 1.5)))

            (setq sLine (read-line fFileIn))

         ) ; end while

      ) ; end progn
      (prompt "\nFile has no data...")
   ) ; end if

   (close fFileIn)

) ; end defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Function to return a list of the attribute data as a list.
; e.g ("TILE MODEL" "TILE COLOUR")
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun GetAttList ( lDataList / sModel sColour )

  (setq sModel (substr lDataList 1 15))

   (setq sColour   (substr lDataList 16 24))
   (if (= sColour "") (setq sColour "        "))

   (list sModel sColour)

) ; end GetAttList
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Returns the number of times a certain attribute occurs within a file.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun GetNoOff ( sString fFile / iCount sLine)

   (setq iCount 0)
   (setq sLine (read-line fFile)) ; read first line of file.

   (while (/= sLine nil)

      (if (= sLine sString)

         (setq iCount (1+ iCount))

      ) ; end if

      ; read next line of file.
      (setq sLine (read-line fFile))

   ) ; end while

   (eval iCount)

) ; end function GetNoOff()
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun GetFilename (/ name oldlen)
  (setq
    name (getvar "dwgname")
    oldlen (- (strlen name) 4)
    name (strcat
            (getvar "dwgprefix")
            (substr name 1 oldlen)  )
  )
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun ExtractData ()

   (prompt "\nExtracting data... Please Wait.\n")

   ; first thing we need to do is extract all the attribute informatiom
   ; using the standard ATTEXT command.
   (command ".ATTEXT" "S" "C:/FASTRACK/TEMPOS" "c:/$TEMP.TXT")

) ; end defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun OpenFile ( sFile sType / fFile)

   (setq fFile (open sFile sType))

   (setq fFile fFile)

) ; end defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Create a list of all the different block attributes within the file.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun CreateList ( fFile / iCount lList sLine)

   (setq iCount 1)

   (setq lList (list))

   (setq sLine (read-line fFile)) ; read first line of file.

   (if (/= sLine nil)
      (progn
         (while (/= sLine nil)

            (if (not (member sLine lList))
               (progn
                  (setq lList (append (list sLine) lList))
               ) ; end progn
            ) ; end if

            ; read next line of file.
            (setq sLine (read-line fFile))

            (setq iCount (1+ iCount))

         ) ; end while

      ) ; end progn
      (prompt "\nFile contains zero data...")
   ) ; end if

   (close fFile)

   (setq lList lList)

) ; end defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Comment this function out when developing code...
;(defun *error* ( msg )
;   (prompt "\nError: ")
;   (princ msg)
;   (setvar "OSMODE" 0)
;   (terpri)
;)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun ONSCR ()

   (setq _cmdecho (getvar "cmdecho"))
   (setq _blipmode (getvar "blipmode"))
   
   (setvar "blipmode" 0)
   (setvar "cmdecho" 0)
   (setvar "attdia" 0)

) ; end defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun OFFSCR ()

   (setvar "blipmode" _blipmode)
   (setvar "cmdecho" _cmdecho)
   (setvar "attdia" 1)

   (princ)

) ; end defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun dtr (Val)
   (* pi (/ Val 180.0))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(princ)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
